/* We don't want gtkdoc scanning this file, it'll get
 * confused by seeing function definitions, so mark it as: */
/*<private_header>*/

static inline void
tf_future_cli_add_signals_for_call_content (DBusGProxy *proxy)
{
  if (!tp_proxy_dbus_g_proxy_claim_for_signal_adding (proxy))
    return;
  dbus_g_proxy_add_signal (proxy, "Removed",
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "StreamsAdded",
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "StreamsRemoved",
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
      G_TYPE_INVALID);
}


static void
_tf_future_cli_call_content_invoke_callback_for_removed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_signal_callback_removed callback =
      (tf_future_cli_call_content_signal_callback_removed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      user_data,
      weak_object);

  if (args != NULL)
    g_value_array_free (args);

  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_content_connect_to_removed (TfFutureCallContent *proxy,
    tf_future_cli_call_content_signal_callback_removed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[1] = {
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_CONTENT, "Removed",
      expected_types,
      NULL, /* no args => no collector function */
      _tf_future_cli_call_content_invoke_callback_for_removed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_content_collect_args_of_streams_added (DBusGProxy *proxy G_GNUC_UNUSED,
    const GPtrArray *arg_Streams,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH));
  g_value_set_boxed (args->values + 0, arg_Streams);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_content_invoke_callback_for_streams_added (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_signal_callback_streams_added callback =
      (tf_future_cli_call_content_signal_callback_streams_added) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_boxed (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_content_connect_to_streams_added (TfFutureCallContent *proxy,
    tf_future_cli_call_content_signal_callback_streams_added callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_CONTENT, "StreamsAdded",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_content_collect_args_of_streams_added),
      _tf_future_cli_call_content_invoke_callback_for_streams_added,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_content_collect_args_of_streams_removed (DBusGProxy *proxy G_GNUC_UNUSED,
    const GPtrArray *arg_Streams,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH));
  g_value_set_boxed (args->values + 0, arg_Streams);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_content_invoke_callback_for_streams_removed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_signal_callback_streams_removed callback =
      (tf_future_cli_call_content_signal_callback_streams_removed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_boxed (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_content_connect_to_streams_removed (TfFutureCallContent *proxy,
    tf_future_cli_call_content_signal_callback_streams_removed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_CONTENT, "StreamsRemoved",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_content_collect_args_of_streams_removed),
      _tf_future_cli_call_content_invoke_callback_for_streams_removed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_content_collect_callback_remove (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_tf_future_cli_call_content_invoke_callback_remove (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_callback_for_remove callback = (tf_future_cli_call_content_callback_for_remove) generic_callback;

  if (error != NULL)
    {
      callback ((TfFutureCallContent *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TfFutureCallContent *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

TpProxyPendingCall *
tf_future_cli_call_content_call_remove (TfFutureCallContent *proxy,
    gint timeout_ms,
    guint in_Reason,
    const gchar *in_Detailed_Removal_Reason,
    const gchar *in_Message,
    tf_future_cli_call_content_callback_for_remove callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = TF_FUTURE_IFACE_QUARK_CALL_CONTENT;
  DBusGProxy *iface;

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL || user_data == NULL, NULL);
  g_return_val_if_fail (callback != NULL || destroy == NULL, NULL);
  g_return_val_if_fail (callback != NULL || weak_object == NULL, NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);

      if (destroy != NULL)
        destroy (user_data);

      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "Remove",
          G_TYPE_UINT, in_Reason,
          G_TYPE_STRING, in_Detailed_Removal_Reason,
          G_TYPE_STRING, in_Message,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "Remove", iface,
          _tf_future_cli_call_content_invoke_callback_remove,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "Remove",
              _tf_future_cli_call_content_collect_callback_remove,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_UINT, in_Reason,
              G_TYPE_STRING, in_Detailed_Removal_Reason,
              G_TYPE_STRING, in_Message,
              G_TYPE_INVALID));

      return data;
    }
}


static void
_tf_future_cli_call_content_interface_audio_control_collect_callback_report_input_volume (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_tf_future_cli_call_content_interface_audio_control_invoke_callback_report_input_volume (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_interface_audio_control_callback_for_report_input_volume callback = (tf_future_cli_call_content_interface_audio_control_callback_for_report_input_volume) generic_callback;

  if (error != NULL)
    {
      callback ((TfFutureCallContent *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TfFutureCallContent *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

TpProxyPendingCall *
tf_future_cli_call_content_interface_audio_control_call_report_input_volume (TfFutureCallContent *proxy,
    gint timeout_ms,
    gint in_Volume,
    tf_future_cli_call_content_interface_audio_control_callback_for_report_input_volume callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_AUDIO_CONTROL;
  DBusGProxy *iface;

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL || user_data == NULL, NULL);
  g_return_val_if_fail (callback != NULL || destroy == NULL, NULL);
  g_return_val_if_fail (callback != NULL || weak_object == NULL, NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);

      if (destroy != NULL)
        destroy (user_data);

      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "ReportInputVolume",
          G_TYPE_INT, in_Volume,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "ReportInputVolume", iface,
          _tf_future_cli_call_content_interface_audio_control_invoke_callback_report_input_volume,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "ReportInputVolume",
              _tf_future_cli_call_content_interface_audio_control_collect_callback_report_input_volume,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_INT, in_Volume,
              G_TYPE_INVALID));

      return data;
    }
}


static void
_tf_future_cli_call_content_interface_audio_control_collect_callback_report_output_volume (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_tf_future_cli_call_content_interface_audio_control_invoke_callback_report_output_volume (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_interface_audio_control_callback_for_report_output_volume callback = (tf_future_cli_call_content_interface_audio_control_callback_for_report_output_volume) generic_callback;

  if (error != NULL)
    {
      callback ((TfFutureCallContent *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TfFutureCallContent *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

TpProxyPendingCall *
tf_future_cli_call_content_interface_audio_control_call_report_output_volume (TfFutureCallContent *proxy,
    gint timeout_ms,
    gint in_Volume,
    tf_future_cli_call_content_interface_audio_control_callback_for_report_output_volume callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_AUDIO_CONTROL;
  DBusGProxy *iface;

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL || user_data == NULL, NULL);
  g_return_val_if_fail (callback != NULL || destroy == NULL, NULL);
  g_return_val_if_fail (callback != NULL || weak_object == NULL, NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);

      if (destroy != NULL)
        destroy (user_data);

      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "ReportOutputVolume",
          G_TYPE_INT, in_Volume,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "ReportOutputVolume", iface,
          _tf_future_cli_call_content_interface_audio_control_invoke_callback_report_output_volume,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "ReportOutputVolume",
              _tf_future_cli_call_content_interface_audio_control_collect_callback_report_output_volume,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_INT, in_Volume,
              G_TYPE_INVALID));

      return data;
    }
}


static inline void
tf_future_cli_add_signals_for_call_content_interface_media (DBusGProxy *proxy)
{
  if (!tp_proxy_dbus_g_proxy_claim_for_signal_adding (proxy))
    return;
  dbus_g_proxy_add_signal (proxy, "CodecsChanged",
      (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))))),
      DBUS_TYPE_G_UINT_ARRAY,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "NewCodecOffer",
      G_TYPE_UINT,
      DBUS_TYPE_G_OBJECT_PATH,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))),
      G_TYPE_INVALID);
}


static void
_tf_future_cli_call_content_interface_media_collect_args_of_codecs_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    GHashTable *arg_Updated_Codecs,
    const GArray *arg_Removed_Contacts,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (2);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 2; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))))));
  g_value_set_boxed (args->values + 0, arg_Updated_Codecs);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, DBUS_TYPE_G_UINT_ARRAY);
  g_value_set_boxed (args->values + 1, arg_Removed_Contacts);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_content_interface_media_invoke_callback_for_codecs_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_interface_media_signal_callback_codecs_changed callback =
      (tf_future_cli_call_content_interface_media_signal_callback_codecs_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_boxed (args->values + 0),
      g_value_get_boxed (args->values + 1),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_content_interface_media_connect_to_codecs_changed (TfFutureCallContent *proxy,
    tf_future_cli_call_content_interface_media_signal_callback_codecs_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[3] = {
      (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))))),
      DBUS_TYPE_G_UINT_ARRAY,
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_MEDIA, "CodecsChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_content_interface_media_collect_args_of_codecs_changed),
      _tf_future_cli_call_content_interface_media_invoke_callback_for_codecs_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_content_interface_media_collect_args_of_new_codec_offer (DBusGProxy *proxy G_GNUC_UNUSED,
    guint arg_Contact,
    const gchar *arg_Offer,
    const GPtrArray *arg_Codecs,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (3);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 3; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_Contact);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, DBUS_TYPE_G_OBJECT_PATH);
  g_value_set_boxed (args->values + 1, arg_Offer);

  g_value_unset (args->values + 2);
  g_value_init (args->values + 2, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))));
  g_value_set_boxed (args->values + 2, arg_Codecs);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_content_interface_media_invoke_callback_for_new_codec_offer (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_interface_media_signal_callback_new_codec_offer callback =
      (tf_future_cli_call_content_interface_media_signal_callback_new_codec_offer) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      g_value_get_boxed (args->values + 1),
      g_value_get_boxed (args->values + 2),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_content_interface_media_connect_to_new_codec_offer (TfFutureCallContent *proxy,
    tf_future_cli_call_content_interface_media_signal_callback_new_codec_offer callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[4] = {
      G_TYPE_UINT,
      DBUS_TYPE_G_OBJECT_PATH,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))),
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_MEDIA, "NewCodecOffer",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_content_interface_media_collect_args_of_new_codec_offer),
      _tf_future_cli_call_content_interface_media_invoke_callback_for_new_codec_offer,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_content_interface_media_collect_callback_update_codecs (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_tf_future_cli_call_content_interface_media_invoke_callback_update_codecs (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_interface_media_callback_for_update_codecs callback = (tf_future_cli_call_content_interface_media_callback_for_update_codecs) generic_callback;

  if (error != NULL)
    {
      callback ((TfFutureCallContent *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TfFutureCallContent *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

TpProxyPendingCall *
tf_future_cli_call_content_interface_media_call_update_codecs (TfFutureCallContent *proxy,
    gint timeout_ms,
    const GPtrArray *in_Codecs,
    tf_future_cli_call_content_interface_media_callback_for_update_codecs callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_MEDIA;
  DBusGProxy *iface;

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL || user_data == NULL, NULL);
  g_return_val_if_fail (callback != NULL || destroy == NULL, NULL);
  g_return_val_if_fail (callback != NULL || weak_object == NULL, NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);

      if (destroy != NULL)
        destroy (user_data);

      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "UpdateCodecs",
          (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))), in_Codecs,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "UpdateCodecs", iface,
          _tf_future_cli_call_content_interface_media_invoke_callback_update_codecs,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "UpdateCodecs",
              _tf_future_cli_call_content_interface_media_collect_callback_update_codecs,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, DBUS_TYPE_G_STRING_STRING_HASHTABLE, G_TYPE_INVALID)))), in_Codecs,
              G_TYPE_INVALID));

      return data;
    }
}


static inline void
tf_future_cli_add_signals_for_call_content_interface_video_control (DBusGProxy *proxy)
{
  if (!tp_proxy_dbus_g_proxy_claim_for_signal_adding (proxy))
    return;
  dbus_g_proxy_add_signal (proxy, "KeyFrameRequested",
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "VideoResolutionChanged",
      (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_UINT, G_TYPE_INVALID)),
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "BitrateChanged",
      G_TYPE_UINT,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "FramerateChanged",
      G_TYPE_UINT,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "MTUChanged",
      G_TYPE_UINT,
      G_TYPE_INVALID);
}


static void
_tf_future_cli_call_content_interface_video_control_invoke_callback_for_key_frame_requested (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_interface_video_control_signal_callback_key_frame_requested callback =
      (tf_future_cli_call_content_interface_video_control_signal_callback_key_frame_requested) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      user_data,
      weak_object);

  if (args != NULL)
    g_value_array_free (args);

  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_content_interface_video_control_connect_to_key_frame_requested (TfFutureCallContent *proxy,
    tf_future_cli_call_content_interface_video_control_signal_callback_key_frame_requested callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[1] = {
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_VIDEO_CONTROL, "KeyFrameRequested",
      expected_types,
      NULL, /* no args => no collector function */
      _tf_future_cli_call_content_interface_video_control_invoke_callback_for_key_frame_requested,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_content_interface_video_control_collect_args_of_video_resolution_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    const GValueArray *arg_NewResolution,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_UINT, G_TYPE_INVALID)));
  g_value_set_boxed (args->values + 0, arg_NewResolution);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_content_interface_video_control_invoke_callback_for_video_resolution_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_interface_video_control_signal_callback_video_resolution_changed callback =
      (tf_future_cli_call_content_interface_video_control_signal_callback_video_resolution_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_boxed (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_content_interface_video_control_connect_to_video_resolution_changed (TfFutureCallContent *proxy,
    tf_future_cli_call_content_interface_video_control_signal_callback_video_resolution_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_UINT, G_TYPE_INVALID)),
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_VIDEO_CONTROL, "VideoResolutionChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_content_interface_video_control_collect_args_of_video_resolution_changed),
      _tf_future_cli_call_content_interface_video_control_invoke_callback_for_video_resolution_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_content_interface_video_control_collect_args_of_bitrate_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    guint arg_NewBitrate,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_NewBitrate);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_content_interface_video_control_invoke_callback_for_bitrate_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_interface_video_control_signal_callback_bitrate_changed callback =
      (tf_future_cli_call_content_interface_video_control_signal_callback_bitrate_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_content_interface_video_control_connect_to_bitrate_changed (TfFutureCallContent *proxy,
    tf_future_cli_call_content_interface_video_control_signal_callback_bitrate_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      G_TYPE_UINT,
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_VIDEO_CONTROL, "BitrateChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_content_interface_video_control_collect_args_of_bitrate_changed),
      _tf_future_cli_call_content_interface_video_control_invoke_callback_for_bitrate_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_content_interface_video_control_collect_args_of_framerate_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    guint arg_NewFramerate,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_NewFramerate);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_content_interface_video_control_invoke_callback_for_framerate_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_interface_video_control_signal_callback_framerate_changed callback =
      (tf_future_cli_call_content_interface_video_control_signal_callback_framerate_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_content_interface_video_control_connect_to_framerate_changed (TfFutureCallContent *proxy,
    tf_future_cli_call_content_interface_video_control_signal_callback_framerate_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      G_TYPE_UINT,
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_VIDEO_CONTROL, "FramerateChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_content_interface_video_control_collect_args_of_framerate_changed),
      _tf_future_cli_call_content_interface_video_control_invoke_callback_for_framerate_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_content_interface_video_control_collect_args_of_mtu_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    guint arg_NewMTU,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_NewMTU);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_content_interface_video_control_invoke_callback_for_mtu_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_content_interface_video_control_signal_callback_mtu_changed callback =
      (tf_future_cli_call_content_interface_video_control_signal_callback_mtu_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_content_interface_video_control_connect_to_mtu_changed (TfFutureCallContent *proxy,
    tf_future_cli_call_content_interface_video_control_signal_callback_mtu_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      G_TYPE_UINT,
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_CONTENT (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_VIDEO_CONTROL, "MTUChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_content_interface_video_control_collect_args_of_mtu_changed),
      _tf_future_cli_call_content_interface_video_control_invoke_callback_for_mtu_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/*
 * tf_future_cli_call_content_add_signals:
 * @self: the #TpProxy
 * @quark: a quark whose string value is the interface
 *   name whose signals should be added
 * @proxy: the D-Bus proxy to which to add the signals
 * @unused: not used for anything
 *
 * Tell dbus-glib that @proxy has the signatures of all
 * signals on the given interface, if it's one we
 * support.
 *
 * This function should be used as a signal handler for
 * #TpProxy::interface-added.
 */
static void
tf_future_cli_call_content_add_signals (TpProxy *self G_GNUC_UNUSED,
    guint quark,
    DBusGProxy *proxy,
    gpointer unused G_GNUC_UNUSED)
{
  if (quark == TF_FUTURE_IFACE_QUARK_CALL_CONTENT)
    tf_future_cli_add_signals_for_call_content (proxy);
  if (quark == TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_MEDIA)
    tf_future_cli_add_signals_for_call_content_interface_media (proxy);
  if (quark == TF_FUTURE_IFACE_QUARK_CALL_CONTENT_INTERFACE_VIDEO_CONTROL)
    tf_future_cli_add_signals_for_call_content_interface_video_control (proxy);
}
