/* We don't want gtkdoc scanning this file, it'll get
 * confused by seeing function definitions, so mark it as: */
/*<private_header>*/

static inline void
tf_future_cli_add_signals_for_call_stream (DBusGProxy *proxy)
{
  if (!tp_proxy_dbus_g_proxy_claim_for_signal_adding (proxy))
    return;
  dbus_g_proxy_add_signal (proxy, "RemoteMembersChanged",
      (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_UINT)),
      DBUS_TYPE_G_UINT_ARRAY,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "LocalSendingStateChanged",
      G_TYPE_UINT,
      G_TYPE_INVALID);
}


static void
_tf_future_cli_call_stream_collect_args_of_remote_members_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    GHashTable *arg_Updates,
    const GArray *arg_Removed,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (2);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 2; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_UINT)));
  g_value_set_boxed (args->values + 0, arg_Updates);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, DBUS_TYPE_G_UINT_ARRAY);
  g_value_set_boxed (args->values + 1, arg_Removed);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_stream_invoke_callback_for_remote_members_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_signal_callback_remote_members_changed callback =
      (tf_future_cli_call_stream_signal_callback_remote_members_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_boxed (args->values + 0),
      g_value_get_boxed (args->values + 1),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_stream_connect_to_remote_members_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_signal_callback_remote_members_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[3] = {
      (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_UINT)),
      DBUS_TYPE_G_UINT_ARRAY,
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_STREAM, "RemoteMembersChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_stream_collect_args_of_remote_members_changed),
      _tf_future_cli_call_stream_invoke_callback_for_remote_members_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_stream_collect_args_of_local_sending_state_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    guint arg_State,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_UINT);
  g_value_set_uint (args->values + 0, arg_State);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_stream_invoke_callback_for_local_sending_state_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_signal_callback_local_sending_state_changed callback =
      (tf_future_cli_call_stream_signal_callback_local_sending_state_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_uint (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_stream_connect_to_local_sending_state_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_signal_callback_local_sending_state_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      G_TYPE_UINT,
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_STREAM, "LocalSendingStateChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_stream_collect_args_of_local_sending_state_changed),
      _tf_future_cli_call_stream_invoke_callback_for_local_sending_state_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_stream_collect_callback_set_sending (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_tf_future_cli_call_stream_invoke_callback_set_sending (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_callback_for_set_sending callback = (tf_future_cli_call_stream_callback_for_set_sending) generic_callback;

  if (error != NULL)
    {
      callback ((TfFutureCallStream *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TfFutureCallStream *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

TpProxyPendingCall *
tf_future_cli_call_stream_call_set_sending (TfFutureCallStream *proxy,
    gint timeout_ms,
    gboolean in_Send,
    tf_future_cli_call_stream_callback_for_set_sending callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = TF_FUTURE_IFACE_QUARK_CALL_STREAM;
  DBusGProxy *iface;

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL || user_data == NULL, NULL);
  g_return_val_if_fail (callback != NULL || destroy == NULL, NULL);
  g_return_val_if_fail (callback != NULL || weak_object == NULL, NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);

      if (destroy != NULL)
        destroy (user_data);

      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "SetSending",
          G_TYPE_BOOLEAN, in_Send,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "SetSending", iface,
          _tf_future_cli_call_stream_invoke_callback_set_sending,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "SetSending",
              _tf_future_cli_call_stream_collect_callback_set_sending,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_BOOLEAN, in_Send,
              G_TYPE_INVALID));

      return data;
    }
}


static void
_tf_future_cli_call_stream_collect_callback_request_receiving (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_tf_future_cli_call_stream_invoke_callback_request_receiving (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_callback_for_request_receiving callback = (tf_future_cli_call_stream_callback_for_request_receiving) generic_callback;

  if (error != NULL)
    {
      callback ((TfFutureCallStream *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TfFutureCallStream *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

TpProxyPendingCall *
tf_future_cli_call_stream_call_request_receiving (TfFutureCallStream *proxy,
    gint timeout_ms,
    guint in_Contact,
    gboolean in_Receive,
    tf_future_cli_call_stream_callback_for_request_receiving callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = TF_FUTURE_IFACE_QUARK_CALL_STREAM;
  DBusGProxy *iface;

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL || user_data == NULL, NULL);
  g_return_val_if_fail (callback != NULL || destroy == NULL, NULL);
  g_return_val_if_fail (callback != NULL || weak_object == NULL, NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);

      if (destroy != NULL)
        destroy (user_data);

      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "RequestReceiving",
          G_TYPE_UINT, in_Contact,
          G_TYPE_BOOLEAN, in_Receive,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "RequestReceiving", iface,
          _tf_future_cli_call_stream_invoke_callback_request_receiving,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "RequestReceiving",
              _tf_future_cli_call_stream_collect_callback_request_receiving,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_UINT, in_Contact,
              G_TYPE_BOOLEAN, in_Receive,
              G_TYPE_INVALID));

      return data;
    }
}


static inline void
tf_future_cli_add_signals_for_call_stream_interface_media (DBusGProxy *proxy)
{
  if (!tp_proxy_dbus_g_proxy_claim_for_signal_adding (proxy))
    return;
  dbus_g_proxy_add_signal (proxy, "LocalCandidatesAdded",
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID)))),
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "LocalCredentialsChanged",
      G_TYPE_STRING,
      G_TYPE_STRING,
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "RelayInfoChanged",
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)))),
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "STUNServersChanged",
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_UINT, G_TYPE_INVALID)))),
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "ServerInfoRetrieved",
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "EndpointsChanged",
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
      G_TYPE_INVALID);
  dbus_g_proxy_add_signal (proxy, "PleaseRestartICE",
      G_TYPE_INVALID);
}


static void
_tf_future_cli_call_stream_interface_media_collect_args_of_local_candidates_added (DBusGProxy *proxy G_GNUC_UNUSED,
    const GPtrArray *arg_Candidates,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID)))));
  g_value_set_boxed (args->values + 0, arg_Candidates);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_stream_interface_media_invoke_callback_for_local_candidates_added (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_interface_media_signal_callback_local_candidates_added callback =
      (tf_future_cli_call_stream_interface_media_signal_callback_local_candidates_added) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_boxed (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_stream_interface_media_connect_to_local_candidates_added (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_local_candidates_added callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID)))),
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA, "LocalCandidatesAdded",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_stream_interface_media_collect_args_of_local_candidates_added),
      _tf_future_cli_call_stream_interface_media_invoke_callback_for_local_candidates_added,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_stream_interface_media_collect_args_of_local_credentials_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    const gchar *arg_Username,
    const gchar *arg_Password,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (2);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 2; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_STRING);
  g_value_set_string (args->values + 0, arg_Username);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, G_TYPE_STRING);
  g_value_set_string (args->values + 1, arg_Password);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_stream_interface_media_invoke_callback_for_local_credentials_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_interface_media_signal_callback_local_credentials_changed callback =
      (tf_future_cli_call_stream_interface_media_signal_callback_local_credentials_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_string (args->values + 0),
      g_value_get_string (args->values + 1),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_stream_interface_media_connect_to_local_credentials_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_local_credentials_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[3] = {
      G_TYPE_STRING,
      G_TYPE_STRING,
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA, "LocalCredentialsChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_stream_interface_media_collect_args_of_local_credentials_changed),
      _tf_future_cli_call_stream_interface_media_invoke_callback_for_local_credentials_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_stream_interface_media_collect_args_of_relay_info_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    const GPtrArray *arg_Relay_Info,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)))));
  g_value_set_boxed (args->values + 0, arg_Relay_Info);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_stream_interface_media_invoke_callback_for_relay_info_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_interface_media_signal_callback_relay_info_changed callback =
      (tf_future_cli_call_stream_interface_media_signal_callback_relay_info_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_boxed (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_stream_interface_media_connect_to_relay_info_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_relay_info_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)))),
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA, "RelayInfoChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_stream_interface_media_collect_args_of_relay_info_changed),
      _tf_future_cli_call_stream_interface_media_invoke_callback_for_relay_info_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_stream_interface_media_collect_args_of_stun_servers_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    const GPtrArray *arg_Servers,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_UINT, G_TYPE_INVALID)))));
  g_value_set_boxed (args->values + 0, arg_Servers);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_stream_interface_media_invoke_callback_for_stun_servers_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_interface_media_signal_callback_stun_servers_changed callback =
      (tf_future_cli_call_stream_interface_media_signal_callback_stun_servers_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_boxed (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_stream_interface_media_connect_to_stun_servers_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_stun_servers_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_UINT, G_TYPE_INVALID)))),
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA, "STUNServersChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_stream_interface_media_collect_args_of_stun_servers_changed),
      _tf_future_cli_call_stream_interface_media_invoke_callback_for_stun_servers_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_stream_interface_media_invoke_callback_for_server_info_retrieved (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_interface_media_signal_callback_server_info_retrieved callback =
      (tf_future_cli_call_stream_interface_media_signal_callback_server_info_retrieved) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      user_data,
      weak_object);

  if (args != NULL)
    g_value_array_free (args);

  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_stream_interface_media_connect_to_server_info_retrieved (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_server_info_retrieved callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[1] = {
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA, "ServerInfoRetrieved",
      expected_types,
      NULL, /* no args => no collector function */
      _tf_future_cli_call_stream_interface_media_invoke_callback_for_server_info_retrieved,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_stream_interface_media_collect_args_of_endpoints_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    const GPtrArray *arg_Endpoints_Added,
    const GPtrArray *arg_Endpoints_Removed,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (2);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 2; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH));
  g_value_set_boxed (args->values + 0, arg_Endpoints_Added);

  g_value_unset (args->values + 1);
  g_value_init (args->values + 1, dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH));
  g_value_set_boxed (args->values + 1, arg_Endpoints_Removed);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_tf_future_cli_call_stream_interface_media_invoke_callback_for_endpoints_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_interface_media_signal_callback_endpoints_changed callback =
      (tf_future_cli_call_stream_interface_media_signal_callback_endpoints_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_boxed (args->values + 0),
      g_value_get_boxed (args->values + 1),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_stream_interface_media_connect_to_endpoints_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_endpoints_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[3] = {
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
      dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA, "EndpointsChanged",
      expected_types,
      G_CALLBACK (_tf_future_cli_call_stream_interface_media_collect_args_of_endpoints_changed),
      _tf_future_cli_call_stream_interface_media_invoke_callback_for_endpoints_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_stream_interface_media_invoke_callback_for_please_restart_ice (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_interface_media_signal_callback_please_restart_ice callback =
      (tf_future_cli_call_stream_interface_media_signal_callback_please_restart_ice) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      user_data,
      weak_object);

  if (args != NULL)
    g_value_array_free (args);

  g_object_unref (tpproxy);
}
TpProxySignalConnection *
tf_future_cli_call_stream_interface_media_connect_to_please_restart_ice (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_please_restart_ice callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[1] = {
      G_TYPE_INVALID };

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA, "PleaseRestartICE",
      expected_types,
      NULL, /* no args => no collector function */
      _tf_future_cli_call_stream_interface_media_invoke_callback_for_please_restart_ice,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

static void
_tf_future_cli_call_stream_interface_media_collect_callback_set_credentials (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_tf_future_cli_call_stream_interface_media_invoke_callback_set_credentials (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_interface_media_callback_for_set_credentials callback = (tf_future_cli_call_stream_interface_media_callback_for_set_credentials) generic_callback;

  if (error != NULL)
    {
      callback ((TfFutureCallStream *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TfFutureCallStream *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

TpProxyPendingCall *
tf_future_cli_call_stream_interface_media_call_set_credentials (TfFutureCallStream *proxy,
    gint timeout_ms,
    const gchar *in_Username,
    const gchar *in_Password,
    tf_future_cli_call_stream_interface_media_callback_for_set_credentials callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA;
  DBusGProxy *iface;

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL || user_data == NULL, NULL);
  g_return_val_if_fail (callback != NULL || destroy == NULL, NULL);
  g_return_val_if_fail (callback != NULL || weak_object == NULL, NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);

      if (destroy != NULL)
        destroy (user_data);

      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "SetCredentials",
          G_TYPE_STRING, in_Username,
          G_TYPE_STRING, in_Password,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "SetCredentials", iface,
          _tf_future_cli_call_stream_interface_media_invoke_callback_set_credentials,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "SetCredentials",
              _tf_future_cli_call_stream_interface_media_collect_callback_set_credentials,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_STRING, in_Username,
              G_TYPE_STRING, in_Password,
              G_TYPE_INVALID));

      return data;
    }
}


static void
_tf_future_cli_call_stream_interface_media_collect_callback_add_candidates (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_tf_future_cli_call_stream_interface_media_invoke_callback_add_candidates (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_interface_media_callback_for_add_candidates callback = (tf_future_cli_call_stream_interface_media_callback_for_add_candidates) generic_callback;

  if (error != NULL)
    {
      callback ((TfFutureCallStream *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TfFutureCallStream *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

TpProxyPendingCall *
tf_future_cli_call_stream_interface_media_call_add_candidates (TfFutureCallStream *proxy,
    gint timeout_ms,
    const GPtrArray *in_Candidates,
    tf_future_cli_call_stream_interface_media_callback_for_add_candidates callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA;
  DBusGProxy *iface;

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL || user_data == NULL, NULL);
  g_return_val_if_fail (callback != NULL || destroy == NULL, NULL);
  g_return_val_if_fail (callback != NULL || weak_object == NULL, NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);

      if (destroy != NULL)
        destroy (user_data);

      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "AddCandidates",
          (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID)))), in_Candidates,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "AddCandidates", iface,
          _tf_future_cli_call_stream_interface_media_invoke_callback_add_candidates,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "AddCandidates",
              _tf_future_cli_call_stream_interface_media_collect_callback_add_candidates,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_INVALID)))), in_Candidates,
              G_TYPE_INVALID));

      return data;
    }
}


static void
_tf_future_cli_call_stream_interface_media_collect_callback_candidates_prepared (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_tf_future_cli_call_stream_interface_media_invoke_callback_candidates_prepared (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  tf_future_cli_call_stream_interface_media_callback_for_candidates_prepared callback = (tf_future_cli_call_stream_interface_media_callback_for_candidates_prepared) generic_callback;

  if (error != NULL)
    {
      callback ((TfFutureCallStream *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TfFutureCallStream *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

TpProxyPendingCall *
tf_future_cli_call_stream_interface_media_call_candidates_prepared (TfFutureCallStream *proxy,
    gint timeout_ms,
    tf_future_cli_call_stream_interface_media_callback_for_candidates_prepared callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA;
  DBusGProxy *iface;

  g_return_val_if_fail (TF_FUTURE_IS_CALL_STREAM (proxy), NULL);
  g_return_val_if_fail (callback != NULL || user_data == NULL, NULL);
  g_return_val_if_fail (callback != NULL || destroy == NULL, NULL);
  g_return_val_if_fail (callback != NULL || weak_object == NULL, NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);

      if (destroy != NULL)
        destroy (user_data);

      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "CandidatesPrepared",
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "CandidatesPrepared", iface,
          _tf_future_cli_call_stream_interface_media_invoke_callback_candidates_prepared,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "CandidatesPrepared",
              _tf_future_cli_call_stream_interface_media_collect_callback_candidates_prepared,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_INVALID));

      return data;
    }
}


/*
 * tf_future_cli_call_stream_add_signals:
 * @self: the #TpProxy
 * @quark: a quark whose string value is the interface
 *   name whose signals should be added
 * @proxy: the D-Bus proxy to which to add the signals
 * @unused: not used for anything
 *
 * Tell dbus-glib that @proxy has the signatures of all
 * signals on the given interface, if it's one we
 * support.
 *
 * This function should be used as a signal handler for
 * #TpProxy::interface-added.
 */
static void
tf_future_cli_call_stream_add_signals (TpProxy *self G_GNUC_UNUSED,
    guint quark,
    DBusGProxy *proxy,
    gpointer unused G_GNUC_UNUSED)
{
  if (quark == TF_FUTURE_IFACE_QUARK_CALL_STREAM)
    tf_future_cli_add_signals_for_call_stream (proxy);
  if (quark == TF_FUTURE_IFACE_QUARK_CALL_STREAM_INTERFACE_MEDIA)
    tf_future_cli_add_signals_for_call_stream_interface_media (proxy);
}
