G_BEGIN_DECLS

typedef void (*tf_future_cli_call_stream_signal_callback_remote_members_changed) (TfFutureCallStream *proxy,
    GHashTable *arg_Updates,
    const GArray *arg_Removed,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *tf_future_cli_call_stream_connect_to_remote_members_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_signal_callback_remote_members_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*tf_future_cli_call_stream_signal_callback_local_sending_state_changed) (TfFutureCallStream *proxy,
    guint arg_State,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *tf_future_cli_call_stream_connect_to_local_sending_state_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_signal_callback_local_sending_state_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*tf_future_cli_call_stream_callback_for_set_sending) (TfFutureCallStream *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *tf_future_cli_call_stream_call_set_sending (TfFutureCallStream *proxy,
    gint timeout_ms,
    gboolean in_Send,
    tf_future_cli_call_stream_callback_for_set_sending callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*tf_future_cli_call_stream_callback_for_request_receiving) (TfFutureCallStream *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *tf_future_cli_call_stream_call_request_receiving (TfFutureCallStream *proxy,
    gint timeout_ms,
    guint in_Contact,
    gboolean in_Receive,
    tf_future_cli_call_stream_callback_for_request_receiving callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*tf_future_cli_call_stream_interface_media_signal_callback_local_candidates_added) (TfFutureCallStream *proxy,
    const GPtrArray *arg_Candidates,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *tf_future_cli_call_stream_interface_media_connect_to_local_candidates_added (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_local_candidates_added callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*tf_future_cli_call_stream_interface_media_signal_callback_local_credentials_changed) (TfFutureCallStream *proxy,
    const gchar *arg_Username,
    const gchar *arg_Password,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *tf_future_cli_call_stream_interface_media_connect_to_local_credentials_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_local_credentials_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*tf_future_cli_call_stream_interface_media_signal_callback_relay_info_changed) (TfFutureCallStream *proxy,
    const GPtrArray *arg_Relay_Info,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *tf_future_cli_call_stream_interface_media_connect_to_relay_info_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_relay_info_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*tf_future_cli_call_stream_interface_media_signal_callback_stun_servers_changed) (TfFutureCallStream *proxy,
    const GPtrArray *arg_Servers,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *tf_future_cli_call_stream_interface_media_connect_to_stun_servers_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_stun_servers_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*tf_future_cli_call_stream_interface_media_signal_callback_server_info_retrieved) (TfFutureCallStream *proxy,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *tf_future_cli_call_stream_interface_media_connect_to_server_info_retrieved (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_server_info_retrieved callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*tf_future_cli_call_stream_interface_media_signal_callback_endpoints_changed) (TfFutureCallStream *proxy,
    const GPtrArray *arg_Endpoints_Added,
    const GPtrArray *arg_Endpoints_Removed,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *tf_future_cli_call_stream_interface_media_connect_to_endpoints_changed (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_endpoints_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*tf_future_cli_call_stream_interface_media_signal_callback_please_restart_ice) (TfFutureCallStream *proxy,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *tf_future_cli_call_stream_interface_media_connect_to_please_restart_ice (TfFutureCallStream *proxy,
    tf_future_cli_call_stream_interface_media_signal_callback_please_restart_ice callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*tf_future_cli_call_stream_interface_media_callback_for_set_credentials) (TfFutureCallStream *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *tf_future_cli_call_stream_interface_media_call_set_credentials (TfFutureCallStream *proxy,
    gint timeout_ms,
    const gchar *in_Username,
    const gchar *in_Password,
    tf_future_cli_call_stream_interface_media_callback_for_set_credentials callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*tf_future_cli_call_stream_interface_media_callback_for_add_candidates) (TfFutureCallStream *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *tf_future_cli_call_stream_interface_media_call_add_candidates (TfFutureCallStream *proxy,
    gint timeout_ms,
    const GPtrArray *in_Candidates,
    tf_future_cli_call_stream_interface_media_callback_for_add_candidates callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*tf_future_cli_call_stream_interface_media_callback_for_candidates_prepared) (TfFutureCallStream *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *tf_future_cli_call_stream_interface_media_call_candidates_prepared (TfFutureCallStream *proxy,
    gint timeout_ms,
    tf_future_cli_call_stream_interface_media_callback_for_candidates_prepared callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


G_END_DECLS
